import _extends from 'babel-runtime/helpers/extends';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { findDOMNode } from 'react-dom';
import invariant from 'invariant';

import { provideDisplayName, omit } from '../utils';

var unselect = [];
// Export Higher Order Sortable Element Component
export default function sortableElement(WrappedComponent) {
  var _class, _temp2;

  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { withRef: false };

  return _temp2 = _class = function (_Component) {
    _inherits(_class, _Component);

    function _class() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, _class);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _class.__proto__ || _Object$getPrototypeOf(_class)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
        selected: false
      }, _this.onSelect = function (e) {
        if (!(e.metaKey || e.ctrlKey)) {
          unselect.forEach(function (func) {
            return func();
          });
          unselect = [];
        }
        _this.setState({
          selected: !_this.state.selected
        });
        if (!_this.state.selected) {
          _this.context.manager.selected.push(_this.node.sortableInfo.index);
          unselect.push(_this.unselect);
        } else {
          var selected = _this.context.manager.selected;
          var index = selected.indexOf(_this.node.sortableInfo);
          selected.splice(index, 1);
          unselect.splice(unselect.indexOf(_this.unselect), 1);
        }
      }, _this.unselect = function () {
        _this.setState({
          selected: false
        });
        var selected = _this.context.manager.selected;
        var index = selected.indexOf(_this.node.sortableInfo);
        selected.splice(index, 1);
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(_class, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.helperClass = this.context.manager.helperClass;
        var _props = this.props,
            collection = _props.collection,
            disabled = _props.disabled,
            index = _props.index;


        if (!disabled) {
          this.setDraggable(collection, index);
        }
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (this.props.index !== nextProps.index && this.node) {
          this.node.sortableInfo.index = nextProps.index;
        }
        if (this.props.disabled !== nextProps.disabled) {
          var collection = nextProps.collection,
              disabled = nextProps.disabled,
              index = nextProps.index;

          if (disabled) {
            this.removeDraggable(collection);
          } else {
            this.setDraggable(collection, index);
          }
        } else if (this.props.collection !== nextProps.collection || nextProps.item && nextProps.item.selectedItems) {
          this.removeDraggable(this.props.collection);
          this.setDraggable(nextProps.collection, nextProps.index);
        }
        if (!nextProps.selected) {
          this.unselect();
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        var _props2 = this.props,
            collection = _props2.collection,
            disabled = _props2.disabled;


        unselect.splice(unselect.indexOf(this.unselect), 1);
        if (!disabled) this.removeDraggable(collection);
      }
    }, {
      key: 'setDraggable',
      value: function setDraggable(collection, index) {
        var node = this.node = findDOMNode(this);

        node.sortableInfo = {
          index: index,
          collection: collection,
          manager: this.context.manager
        };

        this.ref = { node: node };
        this.context.manager.add(collection, this.ref);
      }
    }, {
      key: 'removeDraggable',
      value: function removeDraggable(collection) {
        this.context.manager.remove(collection, this.ref);
      }
    }, {
      key: 'getWrappedInstance',
      value: function getWrappedInstance() {
        invariant(config.withRef, 'To access the wrapped instance, you need to pass in {withRef: true} as the second argument of the SortableElement() call');
        return this.refs.wrappedInstance;
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var ref = config.withRef ? 'wrappedInstance' : null;
        var props = {};
        var item = this.props.item;
        if (item && item.selectedItems) {
          var items = item.selectedItems.map(function (value, index) {
            return React.createElement(WrappedComponent, {
              key: index,
              item: value,
              className: _this2.helperClass
            });
          });
          return React.createElement(
            'div',
            null,
            items
          );
        }
        var component = React.createElement(WrappedComponent, _extends({
          ref: ref,
          className: this.state.selected ? this.helperClass : ''
        }, omit(this.props, 'collection', 'disabled', 'index'), {
          onSelect: this.onSelect
        }, props));
        if (this.context.manager.isMultiple) {
          return React.createElement(
            'div',
            null,
            component
          );
        }
        return component;
      }
    }]);

    return _class;
  }(Component), _class.displayName = provideDisplayName('sortableElement', WrappedComponent), _class.contextTypes = {
    manager: PropTypes.object.isRequired
  }, _class.propTypes = {
    index: PropTypes.number.isRequired,
    collection: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
    disabled: PropTypes.bool
  }, _class.defaultProps = {
    collection: 0
  }, _temp2;
}